// 
unit ServerMethodsUnit1;

interface

uses System.SysUtils, System.Classes, Datasnap.DSServer, Datasnap.DSAuth,
  ServerClassUnit, ServerMainUnit;

type
{$METHODINFO ON}
  TServerMethods1 = class(TComponent)
  private
  public
    function pcCheck(pcName: string; macAddr: string; ipAddr: string): integer;
    function checkMessage(lastDateTime: TDateTime; groupName: string;
      macAddr: String; ipAddr: string; hostName: string;
      sender: string): string;
    function getFullMessage(): string;
    function registMessage(MSG: string): boolean;
    function deleteMessage(dateTime: TDateTime; randam: integer): boolean;
    function getGroupName(): string;
    function getActivePcList(): string;
    function getDateTime(): string;
  end;

{$METHODINFO OFF}

implementation

uses System.StrUtils;

function TServerMethods1.checkMessage(lastDateTime: TDateTime;
  groupName: string; macAddr: String; ipAddr: string; hostName: string;
  sender: string): string;
// ==========================================================================//
// bZ[WE`FbN
// ==========================================================================//
var
  SL: TstringList;
begin
  SL := TstringList.Create;
  SL := ServerClass.getCheckMsgList(lastDateTime, groupName, macAddr, ipAddr,
    hostName, sender);
  Result := SL.Text;
  SL.Free;
end;

function TServerMethods1.deleteMessage(dateTime: TDateTime;
  randam: integer): boolean;
// ==========================================================================//
// bZ[W폜
// ==========================================================================//
begin
  Result := ServerClass.DeleteMsg(dateTime, randam);
end;

function TServerMethods1.getActivePcList: string;
// ==========================================================================//
// gpPCXg̎Q
// ==========================================================================//
var
  SL: TstringList;
begin
  SL := TstringList.Create;
  SL := ServerClass.activePcList;
  Result := SL.Text;
  SL.Free;
end;

function TServerMethods1.getDateTime: string;
begin
// ==========================================================================//
// 擾
// ==========================================================================//
Result:=FormatDateTime('yyyy/mm/dd hh:mm:ss.zzz',now);
end;

function TServerMethods1.getFullMessage: string;
// ==========================================================================//
// bZ[WS擾
// ==========================================================================//
var
  SL: TstringList;
begin
  SL := TstringList.Create;
  SL := ServerClass.getFullMsgList(True);
  Result := SL.Text;
  SL.Free;
end;

function TServerMethods1.getGroupName: string;
// ==========================================================================//
// O[vQ
// ==========================================================================//
begin
  Result := ServerClass.sc_groupName;
end;

function TServerMethods1.pcCheck(pcName, macAddr, ipAddr: string): integer;
// ==========================================================================//
// p\R
// ==========================================================================//
begin
  Result := ServerClass.pcCheck(pcName, macAddr, ipAddr);
end;

function TServerMethods1.registMessage(MSG: string): boolean;
// ==========================================================================//
// bZ[WM
// ==========================================================================//
var
  SL: TstringList;
begin
  SL := TstringList.Create;
  SL.Text := MSG;
  Result := ServerClass.registMessage(SL);
  SL.Free;
end;

end.
