// 
unit u01ClientMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus,
  Vcl.ExtCtrls, Vcl.StdCtrls, ShellAPI, pngimage, Data.DBXDataSnap,
  IPPeerClient, Data.DBXCommon, Data.DbxHTTPLayer, Data.DB, Data.SqlExpr,
  dxAlertWindow, cxGraphics, cxLookAndFeelPainters,
  u02ClientLogic, u03config, u04ClientMsgList, u05SendMsg,
  Vcl.ImgList, Clipbrd, IdBaseComponent, IdMessage;

type
  Tfm_Main = class(TForm)
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    SQLConnection1: TSQLConnection;
    PopupMenu2: TPopupMenu;
    N5: TMenuItem;
    dxAlertWindowManager1: TdxAlertWindowManager;
    Timer2: TTimer;
    cxImageList1: TcxImageList;
    N6: TMenuItem;
    IdMessage1: TIdMessage;
    TrayIcon1: TTrayIcon;
    ImageList1: TImageList;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure umMyMessage(var Message: TMessage); message WM_ACTIVATEAPP;
    procedure Timer2Timer(Sender: TObject);
    procedure N5Click(Sender: TObject);
    procedure N6Click(Sender: TObject);
  private
    procedure WMQueryEndSession(var Msg: TWMQueryEndSession);
      message WM_QUERYENDSESSION;
    procedure sch_backup; // XPW[[
    procedure sch_checkMsg; // XPW[[
    procedure CheckMsg; // `FbNbZ[W
    function GetCurrentMessage(AAlertWindow: TdxAlertWindow)
      : TdxAlertWindowMessage;
  public
    { Public 錾 }
  end;

var
  fm_Main: Tfm_Main;
  ClientLogic: TClientLogic;

  // hWndTrayIcon: Longint; //
  // uTaskBarRecreate: Longint; //
  FQueryEndSession: Boolean; //

implementation

{$R *.dfm}
// Const
// WM_MY_TRAYICON = WM_USER + 100;

procedure Tfm_Main.FormCreate(Sender: TObject);
// ==========================================================================//
// ʕ\
// ==========================================================================//
var
  SL: TStringList;
begin

  Top := 30; // tH[ʂ̏c̒ɕ\܂
  Left := (Screen.Width - Width) - 30; // tH[ʂ̉̒ɕ\܂

  ClientLogic := TClientLogic.Create;
  ClientLogic.iniFileRead;
  ClientLogic.lastDateTime := Now - StrToTime('0:05:00'); // ŏI`FbNԂTOɃZbg
  ClientLogic.networkError := True; // lbg[NG[tOIɂ

  sch_backup; // obNAbv@XPW[[N

  // ^XNg[̕\
  SL := TStringList.Create;
  SL.Delimiter := '\';
  SL.DelimitedText := ExtractFilePath(Application.ExeName);
  TrayIcon1.Hint := 'mint ' + SL.Strings[SL.Count - 2];
  SL.Free;
  TrayIcon1.Visible := True;

  ShowWindow(Application.Handle, SW_HIDE);
  Application.ShowMainForm := False; // ʂ

  ClientLogic.unyolog2('<MintClient start>');

  ClientLogic.backup; // obNAbv

  ClientLogic.unyolog2('Log delete');

  u01ClientMain.fm_Main.SQLConnection1.Params.Values['HostName'] :=
    ClientLogic.cc_HostName;
  u01ClientMain.fm_Main.SQLConnection1.Params.Values['Port'] :=
    IntToStr(ClientLogic.cc_Port);
  u01ClientMain.fm_Main.SQLConnection1.Connected := False;
  try
    u01ClientMain.fm_Main.SQLConnection1.Connected := True;
    if SQLConnection1.Connected = True then
      begin
        ClientLogic.unyolog2('connection OK [' + ClientLogic.cc_HostName + '/' +
          IntToStr(ClientLogic.cc_Port) + ']');
        ClientLogic.cc_LastHostName := ClientLogic.cc_HostName;
        ClientLogic.cc_LastPort := ClientLogic.cc_Port;
        ClientLogic.networkError := False;
        ClientLogic.ClientStatus := False;
      end
    else
      ClientLogic.unyolog2('connection NG [' + ClientLogic.cc_HostName + '/' +
        IntToStr(ClientLogic.cc_Port) + ']');

    // 0@OK
    // 1@pcname no check
    // 2  macaddr no check
    // 3  pcname,macaddr no check
    // -----------------------------------
    // 4  pcname error ,macaddr OK
    // 6  pcname error , macaddr no check
    // 8@macaddr error ,pcname ok
    // 9  macaddr error ,pcname no check
    // 12 pcname error,macaddr error

    case ClientLogic.pcCheck(ClientLogic.GetHostName,
      ClientLogic.GetMACAdress(ClientLogic.GetIpAdress),
      ClientLogic.GetIpAdress) of
      0:
        ClientLogic.ClientStatus := True;
      1:
        ClientLogic.ClientStatus := True;
      2:
        ClientLogic.ClientStatus := True;
      3:
        ClientLogic.ClientStatus := True;
      4:
        begin
          ClientLogic.ClientStatus := False;
          dxAlertWindowManager1.show('G[łBiPCo^j',
            'VXeǗ҂ɘAĂ' + #13#10 + 'PC Name : ' +
            ClientLogic.GetHostName, 14);
          TrayIcon1.IconIndex := 1; // G[\
        end;
      6:
        begin
          ClientLogic.ClientStatus := False;
          dxAlertWindowManager1.show('G[łBiPCo^j',
            'VXeǗ҂ɘAĂ' + #13#10 + 'PC Name : ' +
            ClientLogic.GetHostName, 14);
          TrayIcon1.IconIndex := 1; // G[\
        end;
      8:
        begin
          ClientLogic.ClientStatus := False;
          dxAlertWindowManager1.show('G[łBiMACAhXo^j',
            'VXeǗ҂ɘAĂ' + #13#10 + 'MacAddress : ' +
            ClientLogic.GetMACAdress(ClientLogic.GetIpAdress), 14);
          TrayIcon1.IconIndex := 1; // G[\
        end;
      9:
        begin
          ClientLogic.ClientStatus := False;
          dxAlertWindowManager1.show('G[łBiMACAhXo^j',
            'VXeǗ҂ɘAĂ' + #13#10 + 'MacAddress : ' +
            ClientLogic.GetMACAdress(ClientLogic.GetIpAdress), 14);
          TrayIcon1.IconIndex := 1; // G[\
        end;
      12:
        begin
          ClientLogic.ClientStatus := False;
          dxAlertWindowManager1.show('G[łBiPCo^AMACAhXo^j',
            'VXeǗ҂ɘAĂ' + #13#10 + 'PC Name : ' + ClientLogic.GetHostName
            + ' , MacAddress : ' + ClientLogic.GetMACAdress
            (ClientLogic.GetIpAdress), 14);
          TrayIcon1.IconIndex := 1; // G[\
        end;
    else
      ClientLogic.ClientStatus := False;
      dxAlertWindowManager1.show('G[łB', 'VXeǗ҂ɘAĂ' + #13#10 +
        'PC Name : ' + ClientLogic.GetHostName, 14);
      TrayIcon1.IconIndex := 1; // G[\
    end;

    if ClientLogic.ClientStatus = False then
      begin
        N1.Enabled := False;
        N2.Enabled := False;
        N6.Enabled := False;
      end;

    CheckMsg; // @bZ[W`FbN
    sch_checkMsg; // bZ[W`FbN@XPW[[N

  except
    sch_checkMsg; // bZ[W`FbN@XPW[[N
    N1.Enabled := False;
    N2.Enabled := False;
    N6.Enabled := False;

    // dxAlertWindowManager1.show('ڑG[@' + FormatDateTime('yyyy/mm/dd hh:mm:ss',
    // Now), 'Mint Message Server ɐڑł܂Bҋ@܂B' + #13#10 + 'Host Name : ' +
    // ClientLogic.cc_HostName + ' , Port : http ' +
    // IntToStr(ClientLogic.cc_Port), 14);
    TrayIcon1.IconIndex := 1; // G[\

  end;
end;

procedure Tfm_Main.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
// ==========================================================================//
// tH[N[Y
// ==========================================================================//
begin
  if FQueryEndSession then
    begin
      FQueryEndSession := False;
      // DeleteTaskBarIcon;
      // DeallocateHWnd(hWndTrayIcon);
      ClientLogic.unyolog2('<Windows shutdown>');
      close;
    end
  else
    begin
      // DeleteTaskBarIcon;
      // DeallocateHWnd(hWndTrayIcon);
      ClientLogic.unyolog2('<MintClient end>');
    end;

end;

procedure Tfm_Main.N1Click(Sender: TObject);
// ==========================================================================//
// \
// ==========================================================================//
begin
  if fm_msgList.Showing = True then
    fm_msgList.close
  else
    begin
      fm_msgList.Top := (Screen.Height div 2);
      fm_msgList.Left := (Screen.Width - fm_msgList.Width) - 30;
      fm_msgList.Height := (Screen.Height div 2) - 70;
      fm_msgList.show;
    end;
end;

procedure Tfm_Main.N2Click(Sender: TObject);
// ==========================================================================//
// bZ[WM
// ==========================================================================//
begin
  if fm_sendMsg2.Showing = True then
    fm_sendMsg2.close
  else
    begin
      fm_sendMsg2.Top := 30;
      fm_sendMsg2.Left := (Screen.Width - fm_sendMsg2.Width) - 30;
      fm_sendMsg2.show;
    end;
end;

procedure Tfm_Main.N3Click(Sender: TObject);
// ==========================================================================//
// ݒ
// ==========================================================================//
begin
  if fm_Config2.Showing then
    fm_Config2.close
  else
    begin
      fm_Config2.Top := 30;
      fm_Config2.Left := 30;
      fm_Config2.show;
    end;
end;

procedure Tfm_Main.N4Click(Sender: TObject);
// ==========================================================================//
// I
// ==========================================================================//
begin
  close;
end;

procedure Tfm_Main.N5Click(Sender: TObject);
begin
  Clipboard.AsText := GetCurrentMessage
    (PopupMenu2.PopupComponent as TdxAlertWindow).Text;
end;

procedure Tfm_Main.N6Click(Sender: TObject);
// ==========================================================================//
// ĕ\
// ==========================================================================//
var
  SL: TStringList;
  ML: TStringList;
  I, J: integer;
  sign: Boolean;
  GL: TStringList;
begin
  SL := TStringList.Create;
  ML := TStringList.Create;
  GL := TStringList.Create;
  SL := ClientLogic.getCheckMsgList(Now - StrToDateTime('01:00:00'),
    ClientLogic.cc_GroupName, ClientLogic.GetMACAdress(ClientLogic.GetIpAdress),
    ClientLogic.GetIpAdress, ClientLogic.GetHostName, ClientLogic.cc_sender);
  ClientLogic.lastDateTime := Now;
  ML := ClientLogic.MsgList2(SL);
  for I := 0 to ML.Count - 1 do
    begin
      sign := False;
      if (ClientLogic.csvValue(SL.Strings[I], 5) = '') or
        (ClientLogic.csvValue(SL.Strings[I], 4) = '') or
        (ClientLogic.csvValue(SL.Strings[I], 4) = 'SO[v') then
        sign := True
      else
        begin
          GL.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
          if GL.Count = 0 then
            sign := True;

          for J := 0 to GL.Count - 1 do
            if ClientLogic.csvValue(SL.Strings[I], 5) = GL.Strings[J] then
              sign := True;
        end;
      if sign = True then
        begin
          // fXNgbvʒm\
          dxAlertWindowManager1.OptionsBehavior.DisplayTime := 10000;
          dxAlertWindowManager1.show('[' + ClientLogic.csvValue(SL.Strings[I],
            4) + '] ' + ClientLogic.csvValue(SL.Strings[I], 5) + '@' +
            ClientLogic.csvValue(SL.Strings[I], 1) + '@' +
            ClientLogic.csvValue(SL.Strings[I], 11),
            ClientLogic.TextToMemo(ClientLogic.csvValue(SL.Strings[I], 3)),
            StrToInt(ClientLogic.csvValue(SL.Strings[I], 6)));
        end;
    end;
end;

procedure Tfm_Main.sch_backup;
// ==========================================================================//
// XPW[[@obNAbvIɎs
// ==========================================================================//
var
  intervalTime: integer;
begin
  intervalTime := 3 * 60 * 1000;
  Timer1.Interval := intervalTime;
  Timer1.Enabled := True;
end;

procedure Tfm_Main.sch_checkMsg;
// ==========================================================================//
// XPW[[@`FbNIɎs
// ==========================================================================//
var
  intervalTime, waitTime, I: integer;
begin
  waitTime := StrToInt(FormatDateTime('sszzz', Now));
  for I := 0 to 3 do
    if waitTime > 15000 then
      waitTime := waitTime - 15000;
  waitTime := 15000 - waitTime;

  sleep(waitTime);
  // for I := 1 to 20 do
  // begin
  // sleep(waitTime div 20);
  // Application.ProcessMessages;
  // end;

  intervalTime := ClientLogic.cc_CheckInterval * 1000;
  Timer2.Interval := intervalTime;
  Timer2.Enabled := True;
end;

procedure Tfm_Main.Timer1Timer(Sender: TObject);
// ==========================================================================//
// ^C}[@@obNAbv̋N
// ==========================================================================//
begin
  ClientLogic.backup; // obNAbv
end;

procedure Tfm_Main.Timer2Timer(Sender: TObject);
// ==========================================================================//
// bZ[W`FbN^C}[
// ==========================================================================//
begin
  CheckMsg;
end;

procedure Tfm_Main.CheckMsg;
// ==========================================================================//
// bZ[W`FbNăfXNgbvʒm\
// ==========================================================================//
var
  SL: TStringList;
  ML: TStringList;
  I, J: integer;
  sign: Boolean;
  GL: TStringList;
  time: string;
begin
  sign := False;
  SL := TStringList.Create;
  ML := TStringList.Create;
  GL := TStringList.Create;
  try
    time := DateTimeToStr(Now);
    time := ClientLogic.getServerTime;
    SL := ClientLogic.getCheckMsgList(ClientLogic.lastDateTime,
      ClientLogic.cc_GroupName,
      ClientLogic.GetMACAdress(ClientLogic.GetIpAdress),
      ClientLogic.GetIpAdress, ClientLogic.GetHostName, ClientLogic.cc_sender);

    if SQLConnection1.Connected = True then
      begin
        if ClientLogic.networkError = True then
          begin
            ClientLogic.networkError := False;
            // dxAlertWindowManager1.show
            // ('ڑ@' + FormatDateTime('yyyy/mm/dd hh:mm:ss', Now),
            // 'Mint Message Server ɐڑ܂B' + #13#10 + 'Host Name : ' +
            // ClientLogic.cc_HostName + ' , Port : http ' +
            // IntToStr(ClientLogic.cc_Port), 13);
            TrayIcon1.IconIndex := 0; // 񕜕\

          end;
      end;

    if SQLConnection1.Connected = True then
      if ClientLogic.ClientStatus = False then
        begin
          if ClientLogic.pcCheck(ClientLogic.GetHostName,
            ClientLogic.GetMACAdress(ClientLogic.GetIpAdress),
            ClientLogic.GetIpAdress) <= 3 then
            begin
              ClientLogic.ClientStatus := True;
              dxAlertWindowManager1.show
                ('@' + FormatDateTime('yyyy/mm/dd hh:mm:ss', Now),
                'Mint Message Server ɐڑ܂B' + #13#10 + 'Host Name : ' +
                ClientLogic.cc_HostName + ' , Port : http ' +
                IntToStr(ClientLogic.cc_Port), 13);
              TrayIcon1.IconIndex := 0; // 񕜕\
            end
          else
            ClientLogic.ClientStatus := False;
        end;

    if ClientLogic.ClientStatus = False then
      begin
        N1.Enabled := False;
        N2.Enabled := False;
        N6.Enabled := False;
      end
    else
      begin
        N1.Enabled := True;
        N2.Enabled := True;
        N6.Enabled := True;
      end;

    ClientLogic.lastDateTime := StrToDateTime(time) - StrToDateTime('00:00:01');
    ML := ClientLogic.MsgList2(SL);
    for I := 0 to ML.Count - 1 do
      begin
        sign := False;
        if (ClientLogic.csvValue(SL.Strings[I], 5) = '') or
          (ClientLogic.csvValue(SL.Strings[I], 4) = '') or
          (ClientLogic.csvValue(SL.Strings[I], 4) = 'SO[v') then
          sign := True
        else
          begin
            GL.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
            if GL.Count = 0 then
              sign := True;
            for J := 0 to GL.Count - 1 do
              if ClientLogic.csvValue(SL.Strings[I], 5) = GL.Strings[J] then
                sign := True;
          end;
        if sign = True then
          begin
            // fXNgbvʒm\
            if StrToInt(ClientLogic.csvValue(SL.Strings[I], 6)) = 0 then
              dxAlertWindowManager1.OptionsBehavior.DisplayTime := 10000
            else if StrToInt(ClientLogic.csvValue(SL.Strings[I], 6)) <= 11 then
              dxAlertWindowManager1.OptionsBehavior.DisplayTime := 180000
            else
              dxAlertWindowManager1.OptionsBehavior.DisplayTime := 3600000;

            dxAlertWindowManager1.show('[' + ClientLogic.csvValue(SL.Strings[I],
              4) + '] ' + ClientLogic.csvValue(SL.Strings[I], 5) + '@' +
              ClientLogic.csvValue(SL.Strings[I], 1) + '@' +
              ClientLogic.csvValue(SL.Strings[I], 11),
              ClientLogic.TextToMemo(ClientLogic.csvValue(SL.Strings[I], 3)),
              StrToInt(ClientLogic.csvValue(SL.Strings[I], 6)));
          end;
      end;

    SL.Free;
    ML.Free;
    GL.Free;
  except

    SL.Free;
    ML.Free;
    GL.Free;

    if ClientLogic.networkError = False then
      begin
        ClientLogic.networkError := True;
        // dxAlertWindowManager1.show
        // ('ڑG[@' + FormatDateTime('yyyy/mm/dd hh:mm:ss', Now),
        // 'Mint Message Server Ƃ̐ڑr؂܂Bҋ@܂B' + #13#10 + 'Host Name : ' +
        // ClientLogic.cc_HostName + ' , Port : http ' +
        // IntToStr(ClientLogic.cc_Port), 14);
        TrayIcon1.IconIndex := 1; // G[\
        SQLConnection1.Connected := False;
      end;

    if ClientLogic.networkError = True then
      begin
        N1.Enabled := False;
        N2.Enabled := False;
        N6.Enabled := False;
      end;

  end;

end;

procedure Tfm_Main.umMyMessage(var Message: TMessage);
// ==========================================================================//
// fXNgbvʒm̌n
// ==========================================================================//
var
  I: integer;
begin
  if Message.WParam = WA_INACTIVE then
    for I := dxAlertWindowManager1.Count - 1 downto 0 do
      dxAlertWindowManager1.Items[I].Destroy;
end;

function Tfm_Main.GetCurrentMessage(AAlertWindow: TdxAlertWindow)
  : TdxAlertWindowMessage;
// ==========================================================================//
// fXNgbvʒmFNbv{[hւ̃Rs[p̃JgbZ[W̎擾
// ==========================================================================//
begin
  Result := AAlertWindow.MessageList[AAlertWindow.CurrentMessageIndex];
end;

// procedure Tfm_Main.CreateTaskBarIcon;
/// / ==========================================================================//
/// / ACRgCɓo^
/// / ==========================================================================//
// var
// NotifyData: TNotifyIconData;
// rc: Boolean;
// SL: TStringList;
// I: integer;
// str: string;
//
// begin
// with NotifyData do
// begin
// // cbSize := SizeOf(TNotifyIconData);
// cbSize := 100;
// Wnd := hWndTrayIcon;
// uID := 0;
// uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
//
// SL := TStringList.Create;
// SL.Delimiter := '\';
// SL.DelimitedText := ExtractFilePath(Application.ExeName);
// I := SL.Count - 2;
// str := 'mint ' + SL.Strings[I];
// StrCopy(szTip, PChar(str));
// SL.Free;
//
// hIcon := Application.Icon.Handle;
// uCallbackMessage := WM_MY_TRAYICON;
// end;
// rc := Shell_NotifyIcon(NIM_ADD, @NotifyData);
// if rc then
// else
// begin
// sleep(5000);
// CreateTaskBarIcon;
// end;
// end;

// procedure Tfm_Main.DeleteTaskBarIcon;
/// / ==========================================================================//
/// / ACR폜
/// / ==========================================================================//
// var
// NotifyData: TNotifyIconData;
// begin
// with NotifyData do
// begin
// // cbSize := SizeOf(TNotifyIconData);
// cbSize := 100;
// Wnd := hWndTrayIcon;
// uID := 0;
// end;
// Shell_NotifyIcon(NIM_DELETE, @NotifyData);
// end;

// procedure Tfm_Main.TaskTrayWndProc(var Msg: TMessage);
/// / ==========================================================================//
/// / ^XNgCɗ郁bZ[WM
/// / ==========================================================================//
// var
// ps: TPoint;
// begin
// Case Msg.lParam of
// WM_LBUTTONDBLCLK:
// // _uNbN@ݒʕ\
// begin
// N1Click(Self);
// end;
// WM_LBUTTONUP:
// // NbN@popup menu \
// begin
// GetCursorPos(ps);
// SetForegroundWindow(Handle);
// PopupMenu1.Popup(ps.x, ps.y);
// PostMessage(Handle, WM_NULL, 0, 0);
// end;
// WM_RBUTTONUP:
// // ENbN@popup menu \
// begin
// GetCursorPos(ps);
// SetForegroundWindow(Handle);
// PopupMenu1.Popup(ps.x, ps.y);
// PostMessage(Handle, WM_NULL, 0, 0);
// end;
// else
// // ^XNo[ړEč\zꂽꍇɏACRĐ
// if (Msg.lParam = Longint(uTaskBarRecreate)) then
// CreateTaskBarIcon;
// end;
// end;

// procedure Tfm_Main.UpdateTaskBarIcon;
/// / ==========================================================================//
/// / ^XNgC̃ACRύX
/// / ==========================================================================//
// var
// NotifyData: TNotifyIconData;
// SL: TStringList;
// I: integer;
// str: string;
//
// begin
// with NotifyData do
// begin
// // cbSize := SizeOf(TNotifyIconData);
// cbSize := 100;
// Wnd := hWndTrayIcon;
// uID := 0;
// uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
//
// SL := TStringList.Create;
// SL.Delimiter := '\';
// SL.DelimitedText := ExtractFilePath(Application.ExeName);
// I := SL.Count - 2;
// str := 'mint ' + SL.Strings[I];
// StrCopy(szTip, PChar(str));
// szTip := 'mint';
// SL.Free;
//
// hIcon := Application.Icon.Handle;
// uCallbackMessage := WM_MY_TRAYICON;
// end;
// Shell_NotifyIcon(NIM_MODIFY, @NotifyData);
// end;

procedure Tfm_Main.WMQueryEndSession(var Msg: TWMQueryEndSession);
// ==========================================================================//
// Vbg_ECxg
// ==========================================================================//
begin
  FQueryEndSession := True;
  inherited;
end;

end.
