// 
unit u05sendMsg;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  u04ClientMsgList, Vcl.ComCtrls, cxGraphics, Vcl.ImgList;

type
  Tfm_sendMsg2 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    bt_sendMsg: TButton;
    mm_msg: TMemo;
    ed_sender: TEdit;
    Label6: TLabel;
    lv_icon: TListView;
    cxImageList1: TcxImageList;
    cb_keyword: TComboBox;
    lb_grp: TListBox;
    Label3: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    procedure bt_sendMsgClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  fm_sendMsg2: Tfm_sendMsg2;

implementation

uses
  u01ClientMain;

{$R *.dfm}

procedure Tfm_sendMsg2.bt_sendMsgClick(Sender: TObject);
// ==========================================================================//
// bZ[WM
// ==========================================================================//
var
  MSG: TStringList;
begin
  if (mm_msg.Text = '') or (ed_sender.Text = '') then
    begin
      if mm_msg.Text = '' then
        showmessage('bZ[W͂ĂB')
      else
        showmessage('M҂͂ĂB');
    end
  else
    begin
      if MessageDlg('MėǂłH', mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          MSG := TStringList.Create;
          MSG.Values['dateTime'] := FormatDateTime('yyyy/mm/dd hh:mm:ss', now);
          MSG.Values['dataType'] := IntToStr(1);
          MSG.Values['messageText'] := ClientLogic.MemoToText(mm_msg.Text);
          MSG.Values['groupName'] := lb_grp.Items[lb_grp.ItemIndex];
          if (lb_grp.Items.Text = 'SO[v') or (lb_grp.items.Text = '') then
            MSG.Values['keyword'] := ''
          else
            MSG.Values['keyword'] := cb_keyword.Text;
          MSG.Values['level'] := IntToStr(lv_icon.ItemIndex);
          MSG.Values['randam'] := IntToStr(Random(10000));
          MSG.Values['pcName'] := ClientLogic.GetHostName;
          MSG.Values['macAddr'] := ClientLogic.GetMACAdress
            (ClientLogic.GetIpAdress);
          MSG.Values['ipAddr'] := ClientLogic.GetIpAdress;
          MSG.Values['senderName'] := ed_sender.Text;
          // bZ[WM
          u01ClientMain.ClientLogic.registMessage(MSG);

          // pҖ̍XV
          ClientLogic.cc_sender := MSG.Values['senderName'];
          ClientLogic.iniFileWrite;
          ClientLogic.unyolog2('send: ' + MSG.Values['messageText']);
          MSG.Free;
          // bZ[WꗗXV
          fm_msgList.FormCreate(self);
          if fm_msgList.Showing then
            fm_msgList.StringGrid1.SetFocus;
        end;
    end;
end;

procedure Tfm_sendMsg2.FormCreate(Sender: TObject);
// ==========================================================================//
// Mʍ쐬
// ==========================================================================//
var
  i: integer;
begin
  lb_grp.Clear;
  lb_grp.Items.Add('SO[v');
  lb_grp.Items.Add(ClientLogic.cc_GroupName);
  lb_grp.ItemIndex := 1;

  // ICONꗗ̍쐬
  lv_icon.LargeImages := cxImageList1;
  lv_icon.Clear;
  for i := 0 to cxImageList1.Count - 1 do
    begin
      lv_icon.Items.Add;
      lv_icon.Items[i].Caption := 'Icon' + IntToStr(i);
      lv_icon.Items[i].ImageIndex := i;
    end;
  lv_icon.ItemIndex := 0;
  cb_keyword.Items.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
  ed_sender.Text := ClientLogic.cc_sender;

end;

procedure Tfm_sendMsg2.FormShow(Sender: TObject);
// ==========================================================================//
// Mʁ@\
// ==========================================================================//
begin
  lb_grp.Clear;
  lb_grp.Items.Add('SO[v');
  lb_grp.Items.Add(ClientLogic.cc_GroupName);
  lb_grp.ItemIndex := 1;
  cb_keyword.Items.Text := ClientLogic.TextToMemo(ClientLogic.cc_Keyword);
  ed_sender.Text := ClientLogic.cc_sender;

end;

end.
