// 
unit ServerMsgSendUnit;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, serverMsgListUnit, Vcl.ExtCtrls,
  serverClassUnit, serverConfigUnit, cxGraphics, Vcl.ComCtrls, Vcl.ImgList;

type
  Tfm_sendMsg = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    bt_sendMsg: TButton;
    mm_msg: TMemo;
    ed_keyword: TEdit;
    ed_sender: TEdit;
    cxImageList1: TcxImageList;
    lv_icon: TListView;
    cb_grp: TComboBox;
    Label9: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure bt_sendMsgClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  fm_sendMsg: Tfm_sendMsg;

implementation

uses
  serverMainUnit;

{$R *.dfm}

procedure Tfm_sendMsg.bt_sendMsgClick(Sender: TObject);
// ==========================================================================//
// bZ[WM
// ==========================================================================//
var
  MSG: TStringList;
begin
  if (mm_msg.Text = '') or (ed_sender.Text = '') then
    begin
      if mm_msg.Text = '' then
        showmessage('bZ[W͂ĂB')
      else
        showmessage('M҂͂ĂB');
    end
  else
    begin
      if MessageDlg('MėǂłH', mtWarning, [mbYes, mbNo], 0) = mrYes then
        begin
          MSG := TStringList.Create;
          MSG.Values['dateTime'] := FormatDateTime('yyyy/mm/dd hh:mm:ss',now);
          MSG.Values['dataType'] := IntToStr(1);
          MSG.Values['messageText'] := mm_msg.Text;
          MSG.Values['groupName'] := cb_grp.Text;
          if (cb_grp.Text = 'SO[v') or (cb_grp.Text = '') then
            MSG.Values['keyword'] := ''
          else
            MSG.Values['keyword'] := ed_keyword.Text;
          MSG.Values['level'] := IntToStr(lv_icon.ItemIndex);
          MSG.Values['randam'] := IntToStr(Random(10000));
          MSG.Values['pcName'] := ServerClass.GetHostName;
          MSG.Values['macAddr'] := ServerClass.GetMACAdress
            (ServerClass.GetIpAdress);
          MSG.Values['ipAddr'] := ServerClass.GetIpAdress;
          MSG.Values['senderName'] := ed_sender.Text;
          // bZ[WM
          serverMainUnit.ServerClass.registMessage(MSG);
          MSG.Free;
          // \̍XV
          fm_msgList.FormCreate(self);
          if fm_msgList.Showing then
            fm_msgList.StringGrid1.SetFocus;
          fm_sendMsg.close;
        end;
    end;
end;

procedure Tfm_sendMsg.FormCreate(Sender: TObject);
// ==========================================================================//
// Mʍ쐬
// ==========================================================================//
var
  SL: TStringList;
  i: Integer;
begin
  // O[v̍쐬
  cb_grp.Clear;
  SL := TStringList.Create;
  SL.Delimiter := #9;
  SL.DelimitedText := ServerClass.sc_groupName;
  cb_grp.Items.Add('SO[v');
  for i := 0 to SL.Count - 1 do
    cb_grp.Items.Add(SL.strings[i]);
  cb_grp.ItemIndex := 0;

  // ICONꗗ̍쐬
  lv_icon.LargeImages := cxImageList1;
  lv_icon.Clear;
  for i := 0 to cxImageList1.Count - 1 do
    begin
      lv_icon.Items.Add;
      lv_icon.Items[i].Caption := 'Icon' + IntToStr(i);
      lv_icon.Items[i].ImageIndex := i;
    end;
  lv_icon.ItemIndex := 0;
end;

end.
