unit s01main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DBXDataSnap, IPPeerClient,
  Data.DBXCommon, Data.DbxHTTPLayer, Data.DB, Data.SqlExpr,
  s02logic;

type
  Tfm_main = class(TForm)
    SQLConnection1: TSQLConnection;
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  fm_main: Tfm_main;
  ClientLogic: TClientLogic;

implementation

{$R *.dfm}

function Named(key: string): string;
// IvVẅo
// ӁFIvVꍇ́AɎw肵lD悳܂
var
  ix: integer;
begin
  Named := '';
  for ix := 1 to ParamCount do
    begin
      if copy(ParamStr(ix), 1, length(key) + 2) = '/' + key + ':' then
        Named := copy(ParamStr(ix), length(key) + 3, length(ParamStr(ix)) -
          length(key) + 2);
    end;
end;

procedure Tfm_main.FormCreate(Sender: TObject);
var
  MSG: TStringList;
begin
  // ʂ\
  Application.ShowMainForm := False;
  // logic,methods̐
  ClientLogic := TClientLogic.Create;

  // p[^̃`FbN
  if Named('h') = '' then
    ClientLogic.cc_HostName := 'localhost'
  else
    ClientLogic.cc_HostName := Named('h');

  if Named('p') = '' then
    ClientLogic.cc_Port := 8071
  else
    ClientLogic.cc_Port := StrToInt(Named('p'));
  ClientLogic.cc_LogFileName := 'mint_logfile3.txt';

  MSG := TStringList.Create;
  MSG.Values['dateTime'] := FormatDateTime('yyyy/mm/dd hh:mm:ss', now);
  MSG.Values['dataType'] := IntToStr(1);
  MSG.Values['messageText'] := ClientLogic.MemoToText
    (StringReplace(Named('m'), '#13#10', #13#10, []));
  MSG.Values['groupName'] := Named('g');
  MSG.Values['keyword'] := Named('k');
  MSG.Values['level'] := Named('i');
  MSG.Values['randam'] := IntToStr(Random(10000));
  MSG.Values['pcName'] := ClientLogic.GetHostName;
  MSG.Values['macAddr'] := ClientLogic.GetMACAdress(ClientLogic.GetIpAdress);
  MSG.Values['ipAddr'] := ClientLogic.GetIpAdress;
  MSG.Values['senderName'] := Named('s');
  ClientLogic.unyolog2('MSG:' + MSG.Values['messageText']);

  if MSG.Values['messageText'] = '' then
    begin
      ExitCode := 1; // bZ[W
      ClientLogic.unyolog2('ERROR:bZ[W /m');
      Application.Terminate;
      exit;
    end;
  if MSG.Values['level'] = '' then
    begin
      ExitCode := 2; // ACR
      ClientLogic.unyolog2('ERROR:ACR /i');
      Application.Terminate;
      exit;
    end;
  if MSG.Values['senderName'] = '' then
    begin
      ExitCode := 3; // MҖ
      ClientLogic.unyolog2('ERROR:MҖ /s');
      Application.Terminate;
      exit;
    end;

  // ڑ
  SQLConnection1.Params.Values['HostName'] := ClientLogic.cc_HostName;
  SQLConnection1.Params.Values['Port'] := IntToStr(ClientLogic.cc_Port);
  try
    SQLConnection1.Connected := True;
    if SQLConnection1.Connected = True then
      begin
        ClientLogic.unyolog2('MintSend connection OK [' +
          ClientLogic.cc_HostName + '/' + IntToStr(ClientLogic.cc_Port) + ']');
        ClientLogic.cc_LastHostName := ClientLogic.cc_HostName;
        ClientLogic.cc_LastPort := ClientLogic.cc_Port;
        ClientLogic.networkError := False;
        ClientLogic.ClientStatus := False;
      end;

    // PC`FbN
    ClientLogic.ClientStatus := False;
    case ClientLogic.pcCheck(ClientLogic.GetHostName,
      ClientLogic.GetMACAdress(ClientLogic.GetIpAdress),
      ClientLogic.GetIpAdress) of
      0:
        ClientLogic.ClientStatus := True;
      1:
        ClientLogic.ClientStatus := True;
      2:
        ClientLogic.ClientStatus := True;
      3:
        ClientLogic.ClientStatus := True;
      4:
        begin
          ClientLogic.ClientStatus := False;
          ClientLogic.unyolog2('G[łBiPCo^j' + ClientLogic.GetHostName);
        end;
      6:
        begin
          ClientLogic.ClientStatus := False;
          ClientLogic.unyolog2('G[łBiPCo^j' + ClientLogic.GetHostName);
        end;
      8:
        begin
          ClientLogic.ClientStatus := False;
          ClientLogic.unyolog2('G[łBiMACAhXo^j' + ClientLogic.GetMACAdress
            (ClientLogic.GetIpAdress));
        end;
      9:
        begin
          ClientLogic.ClientStatus := False;
          ClientLogic.unyolog2('G[łBiMACAhXo^j' + ClientLogic.GetMACAdress
            (ClientLogic.GetIpAdress));
        end;
      12:
        begin
          ClientLogic.ClientStatus := False;
          ClientLogic.unyolog2('G[łBiPCo^AMACAhXo^j' + 'PC Name : ' +
            ClientLogic.GetHostName + ' , MacAddress : ' +
            ClientLogic.GetMACAdress(ClientLogic.GetIpAdress));
        end;
    else
      ClientLogic.ClientStatus := False;
      ClientLogic.unyolog2('G[łB' + 'PC Name : ' + ClientLogic.GetHostName);
    end;

    if ClientLogic.ClientStatus = False then
      begin
        ExitCode := 20; // G[
        Application.Terminate;
        exit;
      end
    else
      begin
        // bZ[WM
        ClientLogic.registMessage(MSG);
        // Oo
        ClientLogic.unyolog2('bZ[W𑗐M܂');
        // I
        Application.Terminate;
        exit;
      end;

  except
    ExitCode := 10; // ڑG[
    ClientLogic.unyolog2('MintSend connection NG [' + ClientLogic.cc_HostName +
      '/' + IntToStr(ClientLogic.cc_Port) + ']');
    Application.Terminate;
    exit;
  end;

end;

end.
